# gozerbot/jabbermsg.py
#
#

""" jabber message definition .. types can be normal, chat, groupchat, 
    headline or  error
"""

__copyright__ = 'this file is in the public domain'

from gozerbot.generic import rlog, toenc, fromenc, jabberstrip, makeargrest, \
lockdec
import xmpp, types, time, thread

replylock = thread.allocate_lock()
replylocked = lockdec(replylock)

class Jabbermsg(xmpp.Message):

    """ jabber message object """

    def __init__(self, msg=None):
        if msg:
            xmpp.Message.__init__(self, node=msg)
        else:
            xmpp.Message.__init__(self)
        self.jabber = True
        #self.id = self.getID()
        self.bot = None
        self.botoutput = False
        self.type = self.getType()
        rlog(2, 'jabbermsg', str(self))

    def __del__(self):
        if self.bot:
            self.bot.gcevents += 1

    def filtered(self, txt):
        if not self.filter:
            return False            
        for filter in self.filter:
            if filter in txt:
                return False
        return True

    @replylocked
    def reply(self, txt, result=None, nick=None, dot=False, nritems=False, \
nr=False, fromm=None, private=False):
        """ reply txt .. first check if queue then if DCC then /msg
            otherwise assume channel
        """
        if result == []:
            return
        restxt = ""
        if type(result) == types.DictType:
            for i, j in result.iteritems():
                if type(j) == types.ListType:
                    try:
                        z = ' .. '.join(j)
                    except TypeError:
                        z = unicode(j)
                else:
                    z = j
                if dot == True:
                    restxt += "%s: %s %s " % (i, z, ' .. ')
                elif dot:
                    restxt += "%s: %s %s " % (i, z, dot)
                else:
                    restxt += "%s: %s " % (i, z)
            if restxt:
                if dot == True:
                    restxt = restxt[:-6]
                elif dot:
                    restxt = restxt[:-len(dot)]
        lt = False
        if type(txt) == types.ListType and not result:
            result = txt
            origtxt = ""
            lt = True
        else:
            origtxt = txt
        if result:
            lt = True
        if self.queues:
            for i in self.queues:
                if lt:
                    for j in result:
                        i.put_nowait(j)
                else:
                    i.put_nowait(txt)
            return
        pretxt = origtxt
        if lt and not restxt:
            res = []
            for i in result:
                if type(i) == types.ListType or type(i) == types.TupleType:
                    try:
                        res.append(' .. '.join(i))
                    except TypeError:
                        res.append(unicode(i))
                else:
                    res.append(i)
            result = res
            if nritems:
                if len(txt) > 1:
                    pretxt = "(%s items) .. " % len(result)
            txtlist = [unicode(i) for i in result]
            if not nr is False:
                try:
                    start = int(nr)
                except ValueError:
                    start = 0
                txtlist2 = []
                teller = start
                for i in txtlist:
                    txtlist2.append("%s) %s" % (teller, i))
                    teller += 1
                txtlist = txtlist2
            if dot == True:
                restxt = ' .. '.join(txtlist)
            elif dot:
                restxt = dot.join(txtlist)
            else:
                restxt = ' '.join(txtlist)
        if pretxt:
            restxt = pretxt + restxt
        txt = jabberstrip(restxt)
        if not txt:
            return
        what = txt
        txtlist = []
        start = 0
        end = 2000
        length = len(what)
        for i in range(length/end+1):
            endword = what.find(' ', end)
            if endword == -1:
                endword = end
            txtlist.append(what[start:endword])
            start = endword
            end = start + 2000
        size = 0
        # see if we need to store output in less cache
        if len(txtlist) > 1:
            self.bot.less.add(self.userhost, txtlist)
            size = len(txtlist) - 1
            result = txtlist[:1][0]
            if size:
                result += " (+%s)" % size
        else:
            result = txtlist[0]
        if self.filtered(result):
            return
        repl = self.buildReply(result)
        repl.setNamespace("jabber:client")
        if self.resource == 'jcoll':
            repl.setFrom(self.bot.jid.getStripped() + '/jcollres')
            repl.setTo(self.ruserhost.getStripped())
            self.bot.send(repl)
            return
        if self.groupchat:
            if self.resource == self.bot.nick:
                return
            if private:
                repl.setTo(self.userhost)
            elif self.printto:
                repl.setTo(self.printto)
            else:
                repl.setTo(self.channel)
        if self.bot.google:
            repl.setFrom(self.bot.me)
        #if self.id:
        #    repl.setID(self.id)
        repl.setType(self.type)
        self.bot.send(repl)

    def toirc(self, bot):
        """ set ircevent compat attributes """
        self.jidchange = False
        self.cmnd = 'Message'
        self.conn = None
        self.prefix = ""
        self.postfix = ""
        self.target = ""
        self.arguments = []
        self.resource = fromenc(self.getFrom().getResource())
        self.channel = fromenc(self.getFrom().getStripped())
        self.nick = self.resource
        self.user = ""
        try:
            self.jid = bot.jids[self.channel][self.resource]
            self.jidchange = True
        except KeyError:
            self.jid = self.getFrom()
        self.ruserhost = self.jid
        self.userhost = fromenc(str(self.jid))
        self.stripped = fromenc(self.jid.getStripped())
        self.printto = self.channel
        self.txt = jabberstrip(fromenc(self.getBody()))
        self.origtxt = self.txt
        self.to = fromenc(str(self.getTo()))
        self.time = time.time()
        self.args = []
        self.rest = ' '.join(self.args)
        self.usercmnd = 0
        self.bot = bot
        self.sock = None
        self.closequeue = False
        self.allowqueue = True
        self.inqueue = None
        self.queues = []
        self.speed = 5
        self.options = {}
        self.optionset = []
        self.groups = None
        self.type = self.getType()
        self.cc = ""
        self.alias = ""
        self.aliased = ""
        self.denied = False
        if self.type == 'groupchat':
            self.groupchat = True
        else:
            self.groupchat = False
            self.userhost = self.stripped
        self.msg = not self.groupchat
        self.bot.nrevents += 1
        self.filter = []

    def copyin(self, jmsg):
        """ copy in another jabber message object """
        self.type = unicode(self.type)
        #self.id = unicode(self.id)
        self.jidchange = bool(jmsg.jidchange)
        self.cmnd = unicode(jmsg.cmnd)
        self.conn = jmsg.conn
        self.prefix = unicode(jmsg.prefix)
        self.postfix = unicode(jmsg.postfix)
        self.target = unicode(jmsg.target)
        self.arguments = unicode(jmsg.arguments)
        self.nick = unicode(jmsg.nick)
        self.user = unicode(jmsg.user)
        if not jmsg.jid:
            self.jid = xmpp.JID(jmsg.userhost)
        else:
            self.jid = jmsg.jid
        self.ruserhost = unicode(jmsg.ruserhost)
        self.userhost = unicode(jmsg.userhost)
        self.resource = unicode(jmsg.resource)
        self.stripped = jmsg.stripped
        self.channel = unicode(jmsg.channel)
        self.printto = unicode(jmsg.printto)
        self.txt = unicode(jmsg.txt)
        self.origtxt = unicode(jmsg.origtxt)
        self.to = unicode(jmsg.to)
        self.time = jmsg.time
        self.msg = jmsg.msg
        self.args = list(jmsg.args)
        self.rest = unicode(jmsg.rest)
        self.usercmnd = jmsg.usercmnd
        self.bot = jmsg.bot
        self.sock = jmsg.sock
        self.closequeue = jmsg.closequeue
        self.allowqueue = jmsg.allowqueue
        self.inqueue = jmsg.inqueue
        self.queues = list(jmsg.queues)
        self.printto = jmsg.printto
        self.speed = int(jmsg.speed)
        self.options = dict(jmsg.options)
        self.optionset = list(jmsg.optionset)
        self.groups = jmsg.groups
        self.groupchat = jmsg.groupchat
        self.cc = unicode(jmsg.cc)
        self.alias = unicode(jmsg.alias)
        self.aliased = unicode(jmsg.aliased)
        self.denied = jmsg.denied
        self.filter = list(jmsg.filter)

    def ircstr(self):
        """ return a ircevent repr compatible string """
        return "cmnd=%s printto=%s arguments=%s nick=%s user=%s \
userhost=%s channel=%s txt=%s args=%s rest=%s speed=%s type=%s" % (self.cmnd, \
self.printto, self.arguments, self.nick, self.user, \
self.userhost, self.channel, self.txt, self.args, self.rest, self.speed, \
self.type)

    def missing(self, txt):
        """ method to call when command arguments are missing """
        if self.origtxt:
            splitted = self.origtxt.split() 
            if self.bot.nick in splitted[0]:
                try:
                    cmnd = splitted[1]
                except IndexError:
                    cmnd = splitted[0] 
            elif 'cmnd' in splitted[0]:
                try:
                    cmnd = splitted[2]
                except IndexError:
                    cmnd = splitted[0]
            else:
                if not self.groupchat:
                    cmnd = splitted[0]
                else:
                    if self.aliased:
                        cmnd = self.aliased
                    else:
                        cmnd = splitted[0][1:]
            self.reply(cmnd + ' ' + txt)
        else:
            self.reply('missing origtxt: %s' % txt)
	