# tests/test_bot.py
#
#

__copyright__ = 'this file is in the public domain'

from gozerbot.bot import Bot
import unittest, time

class test_bot(unittest.TestCase):

    def test_connect(self):
        b = Bot()
        b.connect('gozertest', 'localhost')
        self.assert_(b.connected == True)

    def test_reconnect(self):
        b = Bot()
        b.connect('gozertest', 'localhost')
        time.sleep(2)
        b.reconnect()
        self.assert_(b.connected == True)

    def test_breakreadloop(self):
        b = Bot()
        b.connect('gozertest3', 'localhost')
        b.connectok.wait()
        b.sock.shutdown(2)
        b.fsock.write("")
        time.sleep(7)
        self.assert_(b.connected == True)

    def test_breakreadloophammer(self):
        b = Bot()
        b.connect('gozertest3', 'localhost')
        b.connectok.wait()
        for i in range(5):
            try:
                b.sock.shutdown(2)
            except:
                pass
            b.fsock.write("")
        self.assert_(b.connected == True)

    def test_breakreadloophammersleep1(self):
        b = Bot()
        b.connect('gozertest3', 'localhost')
        b.connectok.wait()
        for i in range(5):
            try:
                b.sock.shutdown(2)
            except:
                pass
            b.fsock.write("")
            time.sleep(1)
        self.assert_(b.connected == True)

    def test_breakreadloophammersleep5(self):
        b = Bot()
        b.connect('gozertest3', 'localhost')
        b.connectok.wait()
        for i in range(5):
            try:
                b.sock.shutdown(2)
            except:
                pass
            b.fsock.write("")
            time.sleep(5)
        self.assert_(b.connected == True)

    def test_failsend(self):
        b = Bot()
        b.connect('gozertest3', 'localhost')
        b.connectok.wait()
        b.sock.shutdown(2)
        b.say('#test', 'mekker')
        time.sleep(7)
        self.assert_(b.connected == True)
