# tests/test_rest_server.py
#
#

__copyright__ = 'this file is in the public domain'

from gozerbot.rest.server import RestServer, RestRequestHandler
from gozerbot.rest.client import RestClient
from gozerbot.contrib.simplejson import dumps, loads
from gozerbot.generic import getpostdata
import unittest, time

#server = RestServer(('localhost', 10101), RestRequestHandler)

class test_rest_server(unittest.TestCase):

    def setUp(self):
        self.server = RestServer(('localhost', 10101), RestRequestHandler)

    def test_start(self):
        #server = RestServer(('localhost', 10101), RestRequestHandler)
        self.server.start()
        r = self.server.running
        self.server.shutdown()
        self.assert_(r)

    def test_stop(self):
        #server = RestServer(('localhost', 10101), RestRequestHandler)
        self.server.start()
        self.server.shutdown()
        self.assert_(not self.server.running)

    def test_GET(self):
        def cb(client, request):
            return dumps('yo')            
        self.server.start()
        self.server.addhandler('/test/', 'GET', cb)
        result = RestClient('http://localhost:10101/test/').get()
        self.server.shutdown()
        self.assert_(result.data == 'yo')

    def test_POST(self):
        def cb(client, request):
            data = getpostdata(request)
            return dumps(data)            
        self.server.start()
        self.server.addhandler('/test/', 'POST', cb)
        result = RestClient('http://localhost:10101/test/').post(test='mekker')
        self.server.shutdown()
        self.assert_(result.data['test'] == 'mekker')

    def test_error(self):
        def cb(client, request):
            mekker
            return dumps(data)            
        self.server.start()
        self.server.addhandler('/test/', 'POST', cb)
        result = RestClient('http://localhost:10101/test/').post(test='mekker')
        self.server.shutdown()
        self.assert_(result.error == 501)
